
var appletNotFoundText;

function sign () {

	while (true) {
		if (arangiClientSignatureApplet != undefined) { 
			break;
		}
	}
	
	// Definir el tipo de firma
	arangiClientSignatureApplet.setSignatureType(signatureType);
	
	// Definir si se quieren listar slo los certificados de firma o todos
	try {
		if (allKeyUsagesFilter != undefined) {
			arangiClientSignatureApplet.allKeyUsagesFilter(allKeyUsagesFilter);
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el subject (si existen)
	try {
		if (arraySubjectFilterRules != undefined && arraySubjectFilterRules != null) {
			for (var i=0;i<arraySubjectFilterRules.length;i++) {
				arangiClientSignatureApplet.addSubjectDNFilterRule(arraySubjectFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el issuer (si existen)
	try {
		if (arrayIssuerFilterRules != undefined && arrayIssuerFilterRules != null) {
			for (var i=0;i<arrayIssuerFilterRules.length;i++) {
				arangiClientSignatureApplet.addIssuerDNFilterRule(arrayIssuerFilterRules[i]);
			}
		}
	} catch (e) {}

	// Definir las reglas sobre los nmeros de serie de los certificados (si existen)
	try {
		if (arraySerialNumberFilterRules != undefined && arraySerialNumberFilterRules != null) {
			for (var i=0;i<arraySerialNumberFilterRules.length;i++) {
				arangiClientSignatureApplet.addSerialNumberFilterRule(arraySerialNumberFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir las reglas sobre almacenes utilizados
	try {
		if (disableMozillaKeystore != undefined && disableMozillaKeystore == true) {
			arangiClientSignatureApplet.disableMozillaKeystore();
		}
	} catch (e) {}
	try {
		if (disableIExplorerKeystore != undefined && disableIExplorerKeystore == true) {
			arangiClientSignatureApplet.disableIExplorerKeystore();
		}
	} catch (e) {}
	try {
		if (disablePkcs11Keystores != undefined && disablePkcs11Keystores == true) {
			arangiClientSignatureApplet.disablePkcs11Keystores();
		}
	} catch (e) {}
	try {
		if (useOnlyMozillaKeystore != undefined && useOnlyMozillaKeystore == true) {
			arangiClientSignatureApplet.useOnlyMozillaKeystore();
		}
	} catch (e) {}
	try {
		if (useOnlyIExplorerKeystore != undefined && useOnlyIExplorerKeystore == true) {
			arangiClientSignatureApplet.useOnlyIExplorerKeystore();
		}
	} catch (e) {}
	
	
	// Definir el flag que indica si se debe mostrar el dilogo de seleccin cuando slo
	// hay un certificado para seleccionar
	try {
		if (mostrarSeleccionSiSoloUno != undefined) {
			arangiClientSignatureApplet.setMostrarSeleccionSiSoloUno(mostrarSeleccionSiSoloUno);
		}
	} catch (e) {}
	
	// Definir los parmetros extra para las firmas (si existen)
	try {
		if (arrayExtraParameters != undefined && arrayExtraParameters != null) {
			for (var i=0;i<arrayExtraParameters.length;i++) {
				arangiClientSignatureApplet.addParametroExtraFirma(arrayExtraParameters[i][0], arrayExtraParameters[i][1]);
			}
		}
	} catch (e) {}
	
	// Definir la URL de la TSA (si no se indica se utiliza la TSA de la ACCV)
	try {
		if (urlTSA != undefined) {
			arangiClientSignatureApplet.setUrlTSA(urlTSA);
		}
	} catch (e) {}
	
	// Obtener la referencia para firmas detached
	var reference = null;
	if ($("#signatureReference").length > 0 && $("#signatureReference").val() != '') {
		reference = $("#signatureReference").val();
	}
	
	// Definir el documento a firmar: puede ser un path a fichero o el contenido del fichero a firmar
	if ($("#fileToSign").length > 0 && $("#fileToSign").val() != '') {
		arangiClientSignatureApplet.setFileToSign($("#fileToSign").val(), reference);
	}
	if ($("#contentToSign").length > 0 && $("#contentToSign").val() != '') {
		arangiClientSignatureApplet.setContentToSign($("#contentToSign").val(), reference);
	}
	if ($("#contentToSignBase64").length > 0 && $("#contentToSignBase64").val() != '') {
		arangiClientSignatureApplet.setContentToSignBase64($("#contentToSignBase64").val(), reference);
	}

	// Firmar
	arangiClientSignatureApplet.signReturnStream();
	var signatureB64 = "";
	while(true) {
		trozo = arangiClientSignatureApplet.getResultPiece();
		if (trozo == '') {
			break;
		} else {
			signatureB64 += trozo;
		}
	}
	if (signatureB64 != null) {
		return signatureB64;
	}  else {
		handleError (arangiClientSignatureApplet.getError());
		return null;
	}
		
}

function coSign () {

	while (true) {
		if (arangiClientSignatureApplet != undefined) { 
			break;
		}
	}
	
	
	// Definir el tipo de firma
	arangiClientSignatureApplet.setSignatureType(signatureType);
	
	// Definir si se quieren listar slo los certificados de firma o todos
	try {
		if (allKeyUsagesFilter != undefined) {
			arangiClientSignatureApplet.allKeyUsagesFilter(allKeyUsagesFilter);
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el subject (si existen)
	try {
		if (arraySubjectFilterRules != undefined && arraySubjectFilterRules != null) {
			for (var i=0;i<arraySubjectFilterRules.length;i++) {
				arangiClientSignatureApplet.addSubjectDNFilterRule(arraySubjectFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el issuer (si existen)
	try {
		if (arrayIssuerFilterRules != undefined && arrayIssuerFilterRules != null) {
			for (var i=0;i<arrayIssuerFilterRules.length;i++) {
				arangiClientSignatureApplet.addIssuerDNFilterRule(arrayIssuerFilterRules[i]);
			}
		}
	} catch (e) {}

	// Definir las reglas sobre los nmeros de serie de los certificados (si existen)
	try {
		if (arraySerialNumberFilterRules != undefined && arraySerialNumberFilterRules != null) {
			for (var i=0;i<arraySerialNumberFilterRules.length;i++) {
				arangiClientSignatureApplet.addSerialNumberFilterRule(arraySerialNumberFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir la firma: puede ser un path a fichero o el contenido de la misma
	if ($("#signatureFile").length > 0 && $("#signatureFile").val() != '') {
		arangiClientSignatureApplet.setSignatureFile($("#signatureFile").val());
	}
	if ($("#signatureContent").length > 0 && $("#signatureContent").val() != '') {
		arangiClientSignatureApplet.setSignatureContent($("#signatureContent").val());
	}
	if ($("#signatureContentBase64").length > 0 && $("#signatureContentBase64").val() != '') {
		arangiClientSignatureApplet.setSignatureContentBase64($("#signatureContentBase64").val());
	}

	// Definir el documento a firmar: puede ser un path a fichero o el contenido del fichero a firmar
	if ($("#fileToSign").length > 0 && $("#fileToSign").val() != '') {
		arangiClientSignatureApplet.setFileToSign($("#fileToSign").val(), null);
	}
	if ($("#contentToSign").length > 0 && $("#contentToSign").val() != '') {
		arangiClientSignatureApplet.setContentToSign($("#contentToSign").val(), null);
	}
	if ($("#contentToSignBase64").length > 0 && $("#contentToSignBase64").val() != '') {
		arangiClientSignatureApplet.setContentToSignBase64($("#contentToSignBase64").val(), null);
	}

	// Cofirmar
	arangiClientSignatureApplet.coSignReturnStream();
	var signatureB64 = "";
	while(true) {
		trozo = arangiClientSignatureApplet.getResultPiece();
		if (trozo == '') {
			break;
		} else {
			signatureB64 += trozo;
		}
	}
	if (signatureB64 != null) {
		return signatureB64;
	}  else {
		handleError (arangiClientSignatureApplet.getError());
		return null;
	}
		
}

function counterSign () {

	while (true) {
		if (arangiClientSignatureApplet != undefined) { 
			break;
		}
	}
	
	
	// Definir el tipo de firma
	arangiClientSignatureApplet.setSignatureType(signatureType);
	
	// Definir si se quieren listar slo los certificados de firma o todos
	try {
		if (allKeyUsagesFilter != undefined) {
			arangiClientSignatureApplet.allKeyUsagesFilter(allKeyUsagesFilter);
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el subject (si existen)
	try {
		if (arraySubjectFilterRules != undefined && arraySubjectFilterRules != null) {
			for (var i=0;i<arraySubjectFilterRules.length;i++) {
				arangiClientSignatureApplet.addSubjectDNFilterRule(arraySubjectFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir las reglas para el filtro sobre el issuer (si existen)
	try {
		if (arrayIssuerFilterRules != undefined && arrayIssuerFilterRules != null) {
			for (var i=0;i<arrayIssuerFilterRules.length;i++) {
				arangiClientSignatureApplet.addIssuerDNFilterRule(arrayIssuerFilterRules[i]);
			}
		}
	} catch (e) {}

	// Definir las reglas sobre los nmeros de serie de los certificados (si existen)
	try {
		if (arraySerialNumberFilterRules != undefined && arraySerialNumberFilterRules != null) {
			for (var i=0;i<arraySerialNumberFilterRules.length;i++) {
				arangiClientSignatureApplet.addSerialNumberFilterRule(arraySerialNumberFilterRules[i]);
			}
		}
	} catch (e) {}
	
	// Definir la firma: puede ser un path a fichero o el contenido de la misma
	if ($("#signatureFile").length > 0 && $("#signatureFile").val() != '') {
		arangiClientSignatureApplet.setSignatureFile($("#signatureFile").val());
	}
	if ($("#signatureContent").length > 0 && $("#signatureContent").val() != '') {
		arangiClientSignatureApplet.setSignatureContent($("#signatureContent").val());
	}
	if ($("#signatureContentBase64").length > 0 && $("#signatureContentBase64").val() != '') {
		arangiClientSignatureApplet.setSignatureContentBase64($("#signatureContentBase64").val());
	}

	// Contrafirmar
	arangiClientSignatureApplet.counterSignReturnStream();
	var signatureB64 = "";
	while(true) {
		trozo = arangiClientSignatureApplet.getResultPiece();
		if (trozo == '') {
			break;
		} else {
			signatureB64 += trozo;
		}
	}
	if (signatureB64 != null) {
		return signatureB64;
	}  else {
		handleError (arangiClientSignatureApplet.getError());
		return null;
	}
		
}

function validate () {

	if (arangiClientValidationApplet == undefined) { 
		if (appletNotFoundText != undefined) {
			alert(appletNotFoundText);
		} else {
			alert(defaultAppletNotFoundText);
		}
	    return null;
	}

	// Definir el tipo de firma
	arangiClientValidationApplet.setSignatureType(signatureType);
	
	// Definir la firma: puede ser un path a fichero o el contenido de la misma
	if ($("#detachedFile").length > 0 && $("#detachedFile").val() != '') {
		arangiClientValidationApplet.setDetachedFile ($("#detachedFile").val());
	}
	if ($("#detachedContent").length > 0 && $("#detachedContent").val() != '') {
		arangiClientValidationApplet.setDetachedContent ($("#detachedContent").val());
	}
	if ($("#detachedContentBase64").length > 0 && $("#detachedContentBase64").val() != '') {
		arangiClientValidationApplet.setDetachedContentBase64 ($("#detachedContentBase64").val());
	}
	if ($("#fileToValidate").length > 0 && $("#fileToValidate").val() != '') {
		arangiClientValidationApplet.setSignatureFile($("#fileToValidate").val());
	}
	if ($("#contentToValidate").length > 0 && $("#contentToValidate").val() != '') {
		arangiClientValidationApplet.setSignatureContent($("#contentToValidate").val());
	}
	if ($("#contentToValidateBase64").length > 0 && $("#contentToValidateBase64").val() != '') {
		arangiClientValidationApplet.setSignatureContentBase64($("#contentToValidateBase64").val());
	}
	
	// Validar
	var validationResult = arangiClientValidationApplet.validateSignature();
	if (validationResult != null) {
		return validationResult;
	}  else {
		handleError (arangiClientValidationApplet.getError());
		return null;
	}
		
}

function save (documentB64) {
	
	while (true) {
		if (arangiClientSignatureApplet != undefined) { 
			break;
		}
	}
	
	//-- Buscar el applet
	var applet;
	if (arangiClientSignatureApplet != undefined) {
		applet = arangiClientSignatureApplet;
	} else {
		applet = arangiClientValidationApplet;
	}
	
	// Guardar
	if (!applet.save(documentB64)) {
		if (applet.getError() != null) {
			handleError (applet.getError());
			return false;
		} else {
			//-- Operacin cancelada por el usuario
			handleOperationCancelled ();
			return false;
		}
	}

	return true;
}

function getPath (textFieldID) {
	
	while (true) {
		if (arangiClientSignatureApplet != undefined) { 
			break;
		}
	}
	
	//-- Buscar el applet
	var applet;
	if (arangiClientSignatureApplet != undefined) {
		applet = arangiClientSignatureApplet;
	} else {
		applet = arangiClientValidationApplet;
	}
	
	//-- Dejar que el usuario elija un fichero
	path = applet.getPath();
	if (path != null) {
		document.getElementById(textFieldID).value=path;
	}
}