package es.accv.arangi.client;

/**
 * Clase con constantes para validar
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class ValidationConstants {

	/**
	 * Tipo de firma PKCS#7
	 */
	public static final String SIGNATURE_PKCS7			= "pkcs7";
	
	/**
	 * Tipo de firma CMS
	 */
	public static final String SIGNATURE_CMS			= "cms";
	
	/**
	 * Tipo de firma PDF con sello de tiempos
	 */
	public static final String SIGNATURE_PDF	= "pdf";
	
	/**
	 * Tipo de firma XAdES
	 */
	public static final String SIGNATURE_XADES	= "xades";
	
	

}
