package es.accv.arangi.client.exception;

/**
 * El fichero a parsear no es un certificado digital
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class MalformedCertificateException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public MalformedCertificateException() {
	}

	/**
	 * @param message
	 */
	public MalformedCertificateException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public MalformedCertificateException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public MalformedCertificateException(String message, Throwable cause) {
		super(message, cause);
	}

}
