package es.accv.arangi.client.exception;

/**
 * No se ha pasado el documento que se firm y la firma es detached
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class NoDetachedDocumentToValidateException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public NoDetachedDocumentToValidateException() {
	}

	/**
	 * @param message
	 */
	public NoDetachedDocumentToValidateException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public NoDetachedDocumentToValidateException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public NoDetachedDocumentToValidateException(String message, Throwable cause) {
		super(message, cause);
	}

}
