package es.accv.arangi.client.exception;

/**
 * El tipo de firma demandado no existe en esta aplicacin
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class SignatureCancelledByUserException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public SignatureCancelledByUserException() {
	}

	/**
	 * @param message
	 */
	public SignatureCancelledByUserException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public SignatureCancelledByUserException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public SignatureCancelledByUserException(String message, Throwable cause) {
		super(message, cause);
	}

}
