package es.accv.arangi.client.exception;

/**
 * El proceso de firma ha sido cancelado por el usuario
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class SignatureTypeUnknownException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public SignatureTypeUnknownException() {
	}

	/**
	 * @param message
	 */
	public SignatureTypeUnknownException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public SignatureTypeUnknownException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public SignatureTypeUnknownException(String message, Throwable cause) {
		super(message, cause);
	}

}
