import java.io.File;
import java.util.HashMap;

import es.accv.arangi.base.util.Util;
import es.accv.arangi.client.ArangiClient;
import es.accv.arangi.client.ArangiClientSignatureApplet;
import es.accv.arangi.client.SignatureConstants;
import es.accv.arangi.client.filter.ArangiClientFilter;


public class PruebaFirma {

	public static void main (String[] args) {
		ArangiClient client = new ArangiClient(null, null);
		client.setMostrarSeleccionSiSoloUno(false);
//		client.setUrlTSA("http://tss2.accv.es/tsa");
		
		HashMap<String, Object> options = new HashMap<String, Object>();
		options.put(ArangiClient.OPCION_IMAGE_PATH, "d:/temp/misfits.jpg");
		options.put(ArangiClient.OPCION_X_BOTTOM_LEFT, "100");
		options.put(ArangiClient.OPCION_Y_BOTTOM_LEFT, "100");
		options.put(ArangiClient.OPCION_X_TOP_RIGHT, "200");
		options.put(ArangiClient.OPCION_Y_TOP_RIGHT, "200");
		options.put(ArangiClient.OPCION_PAGE, "1");
		client.setOpciones(options);
		
		ArangiClientFilter filter = new ArangiClientFilter();
		filter.setAllKeyUsages(false);
//		filter.addSubjectDNFilterRule("CN=PEPE PRUEBA APSC - DNI 29999908L");
//		filter.addSubjectDNFilterRule("CN=PEPE MANSANILLA");
//		filter.setMozillaKeystore(false);
//		filter.setIExplorerKeystore(false);
//		filter.addSerialNumberFilterRule("1B791BFB1BC07CE9");
//		filter.addIssuerDNFilterRule("CN=ACCVCATEST-120");
//		filter.addFilterIssuerDN("CN=SUB");
		
		File file = new File("d:/temp/Firmas/pdf_sinfirmar.pdf");
		
		try {
			Util.saveFile(new File("d:/temp/GIBAJA_2004_firmado.pdf"), 
					Util.decodeBase64(client.signFile(file, filter, "", SignatureConstants.SIGNATURE_TIMESTAMP_PDF)));
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	public static void main0 (String args[]) {
		
		ArangiClientSignatureApplet applet = new ArangiClientSignatureApplet();
		applet.init();
		applet.setSignatureType("pdf");
//		applet.setContentToSignBase64("SG9sYSBtdW5kbw==", "prueba");
		applet.setFileToSign("d:/temp/GIBAJA_2004.pdf", "");
		
		System.out.println("*******************************");
		System.out.println (applet.sign());
		
	}
	
	
}
