package es.accv.arangi.client.exception;

/**
 * No hay un certificado para firmar
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class NoCertificateToSignException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public NoCertificateToSignException() {
	}

	/**
	 * @param message
	 */
	public NoCertificateToSignException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public NoCertificateToSignException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public NoCertificateToSignException(String message, Throwable cause) {
		super(message, cause);
	}

}
