package es.accv.arangi.client.exception;

/**
 * La firma no puede ser cargada
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class SignatureFormatException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * 
	 */
	public SignatureFormatException() {
	}

	/**
	 * @param message
	 */
	public SignatureFormatException(String message) {
		super(message);
	}

	/**
	 * @param cause
	 */
	public SignatureFormatException(Throwable cause) {
		super(cause);
	}

	/**
	 * @param message
	 * @param cause
	 */
	public SignatureFormatException(String message, Throwable cause) {
		super(message, cause);
	}

}
