package es.accv.arangi.client.util;

import es.accv.arangi.base.device.model.Pkcs11Device;

/**
 * Clase que almacena un pin y un dispositivo PKCS#11
 * 
 * @author <a href="mailto:jgutierrez@accv.es">Jos M Gutirrez</a>
 */
public class PinAndPkcs11Device {

	Pkcs11Device device;
	String pin;

	/**
	 * @param device
	 * @param pin
	 */
	public PinAndPkcs11Device(Pkcs11Device device, String pin) {
		super();
		this.device = device;
		this.pin = pin;
	}

	public Pkcs11Device getDevice() {
		return device;
	}

	public void setDevice(Pkcs11Device device) {
		this.device = device;
	}

	public String getPin() {
		return pin;
	}

	public void setPin(String pin) {
		this.pin = pin;
	}
	

}
