import java.io.File;
import java.io.FileNotFoundException;

import es.accv.arangi.base.certificate.Certificate;
import es.accv.arangi.base.exception.certificate.NormalizeCertificateException;
import es.accv.arangi.base.util.Util;


public class PruebaCertificadoFirmaE {

	public static void main(String[] args) {
		Certificate certificate;
		try {
//			certificate = new Certificate (Util.getCertificate(new File ("c:/temp/firmaE.crt")));
			certificate = new Certificate (Util.getCertificate(new File ("d:/desarrollo/certificados/accv-ca2.crt")));
		} catch (NormalizeCertificateException e) {
			e.printStackTrace();
			return;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}
		
		System.out.println (certificate.isKeyUsageDigitalSignature());
	}

}
