import java.io.File;

import es.accv.arangi.client.ArangiClient;
import es.accv.arangi.client.ValidationConstants;
import es.accv.arangi.client.model.ValidationObject;


public class PruebaValidacion {

	public static void main (String[] args) {
		ArangiClient client = new ArangiClient(null, null);
		try {
			ValidationObject result = client.validateSignature(new File ("c:/temp/firmas/pades_multiple.pdf"), ValidationConstants.SIGNATURE_PDF);
			for (int i = 0; i < result.getSignatureValidationResults().length; i++) {
				System.out.println ("Firma " + i);
				System.out.println ("");
				System.out.println (result.getSignatureValidationResults()[i].isValid());
				System.out.println (result.getSignatureValidationResults()[i].getInvalidMessage());
			}
			
			System.out.println (client.getSignatureValidationResultXML(result));
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	
}
