package es.accv.arangi.client.test;

import java.io.IOException;

import junit.framework.TestCase;
import es.accv.arangi.base.util.Util;
import es.accv.arangi.client.xstream.ValidationResultUtil;
import es.accv.arangi.client.xstream.XStreamValidationResult;

public class TestXStream extends TestCase {

	public void testLectura () {
		
		String xml;
		try {
			xml = new String (Util.readStream(ClassLoader.getSystemResourceAsStream("resultado_validacion.xml")));
		} catch (IOException e) {
			e.printStackTrace();
			fail (e.getMessage());
			return;
		}
		
		XStreamValidationResult result;
		try {
			result = ValidationResultUtil.getValidationResultObject(xml);
		} catch (Exception e) {
			e.printStackTrace();
			fail (e.getMessage());
			return;
		}
		
		assertEquals("No hay exactamente una firma", result.getSignatures().length, 1);

	}
	
	
}
